<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\CompanyRelRoutingTag\CompanyRelRoutingTag;
use Ivoz\Provider\Domain\Model\CompanyRelRoutingTag\CompanyRelRoutingTagRepository;
use Symfony\Bridge\Doctrine\RegistryInterface;

/**
 * CompanyRelRoutingTagDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CompanyRelRoutingTagDoctrineRepository extends ServiceEntityRepository implements CompanyRelRoutingTagRepository
{
    public function __construct(RegistryInterface $registry)
    {
        parent::__construct($registry, CompanyRelRoutingTag::class);
    }

    /**
     * Used by client API access controls
     * @return int[]
     */
    public function getRoutingTagIdsByCompany(int $companyId): array
    {
        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $qb
            ->select('IDENTITY(self.routingTag) AS routingTag')
            ->where(
                $expression->eq('self.company', $companyId)
            );

        $result = $qb->getQuery()->getScalarResult();

        return array_map(
            function ($val) {
                return $val !== null
                    ? intval($val)
                    : null;
            },
            array_column($result, 'routingTag')
        );
    }
}
