<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Core\Infrastructure\Persistence\Doctrine\Model\Helper\CriteriaHelper;
use Ivoz\Provider\Domain\Model\WebPortal\WebPortal;
use Ivoz\Provider\Domain\Model\WebPortal\WebPortalInterface;
use Ivoz\Provider\Domain\Model\WebPortal\WebPortalRepository;
use Symfony\Bridge\Doctrine\RegistryInterface;

/**
 * WebPortalDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class WebPortalDoctrineRepository extends ServiceEntityRepository implements WebPortalRepository
{
    public function __construct(RegistryInterface $registry)
    {
        parent::__construct($registry, WebPortal::class);
    }

    /**
     * @param string $serverName
     * @return WebPortalInterface | null
     */
    public function findUserUrlByServerName(string $serverName)
    {
        $conditions = [
            'url' => 'https://' . $serverName,
            'urlType' => 'user'
        ];
        /** @var WebPortalInterface $response */
        $response = $this->findOneBy($conditions);

        return $response;
    }
}
